unit bearbeitenUnit;

interface

uses
  System.SysUtils, System.Classes, JS, Web, WEBLib.Graphics, WEBLib.Controls,
  WEBLib.Forms, WEBLib.Dialogs, Vcl.StdCtrls, WEBLib.StdCtrls, Vcl.Controls,
  WEBLib.ExtCtrls, Data.DB, WEBLib.DB, WEBLib.CDS, WEBLib.REST, WEBLIB.JSON,
  WEBLib.Devices, System.NetEncoding, WEBLib.LocalFiles, WEBLib.ClientConnector,
  WEBLib.FirestoreCDS, WEBLib.IndexedDb, WEBLib.Grids, WEBLib.DBCtrls, Vcl.Grids,
  Vcl.Imaging.jpeg, WEBLib.Actions;

type
  TForm2 = class(TWebForm)
    WebElementActionList1: TWebElementActionList;
    WebImageControl: TWebImageControl;
    keepAliveTimer: TWebTimer;
    IndexedDb: TWebIndexedDbClientDataset;
    DataSourceDB: TWebDataSource;
    WebRESTClient1: TWebRESTClient;
    wbDelete: TWebButton;
    wbSendData: TWebButton;
    DBGridDB: TWebDBGrid;
    procedure WebElementActionList1Actions0Execute(Sender: TObject; Element: TJSHTMLElementRecord; Event: TJSEventParameter);
    procedure WebElementActionList1Actions1Execute(Sender: TObject; Element: TJSHTMLElementRecord; Event: TJSEventParameter);
    procedure WebFormShow(Sender: TObject);
    procedure wbResetClick(Sender: TObject);
    procedure DBGridDBClickCell(Sender: TObject; ACol, ARow: Integer);
    procedure sendImage();
    procedure WebFormCreate(Sender: TObject);
    procedure wbSendDataClick(Sender: TObject);
    procedure getOnlineState(Sender: TObject);
    procedure wbDeleteClick(Sender: TObject);
    procedure WebRESTClient1Error(Sender: TObject; ARequest: TJSXMLHttpRequestRecord; Event: TJSEventRecord; var Handled: Boolean);
    procedure WebRESTClient1Response(Sender: TObject; AResponse: string);
  private
    FJSONObject: TJSONObject;
    fJSONArray : TJSONArray;
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
    Form2: TForm2;

    serverState     : boolean = false;

implementation

uses
    erfassenUnit;

{$R *.dfm}

{ ***************************************************************************
 *  Delete image in imagecontrol                                                                         *
  ***************************************************************************  }
procedure TForm2.wbResetClick(Sender: TObject);
begin
    WebImageControl.url := '';
end;


{ ***************************************************************************
 *    Todo / not implemented jet                                             *
  ***************************************************************************  }
procedure TForm2.WebElementActionList1Actions0Execute(Sender: TObject;
  Element: TJSHTMLElementRecord; Event: TJSEventParameter);
begin
    {ID=side1}
    IndexedDb.Active := false;
    Application.CreateForm(TForm1, Form1);
end;

{ ***************************************************************************
 *    Todo / not implemented jet                                             *
  ***************************************************************************  }
procedure TForm2.WebElementActionList1Actions1Execute(Sender: TObject;
  Element: TJSHTMLElementRecord; Event: TJSEventParameter);
begin
    {ID=siee2}
end;

{ ***************************************************************************
 *                                                                           *
  ***************************************************************************  }
procedure TForm2.getOnlineState(Sender: TObject);
var
    ja: TJSONArray;
    jo: TJSONObject;
    temp : string;
begin
    jo := TJSONObject.Create;
    jo.AddPair('ACK', TJSONString.Create('OK'));
    temp := jo.ToString;

    WebRESTClient1.HttpsPost('https://edv86.wolf-intranet.de:8080/keepAlive', 'application/json', jo.ToString);
end;

{ ***************************************************************************
 *   Wenn die Form erzeugt wird                                                                        *
  ***************************************************************************  }
procedure TForm2.WebFormCreate(Sender: TObject);
begin
     // Setup permanent indexes
    IndexedDB.AddIDBIndex('AB_Nr', 'ab');
    IndexedDB.AddIDBIndex('Anlage', 'anlage');
    IndexedDB.AddIDBIndex('Datum', 'date');
    IndexedDB.AddIDBIndex('Zeit', 'time');
    IndexedDB.AddIDBIndex('ImageData', 'imageData');
    IndexedDB.AddIDBIndex('ImageUrl', 'imageUrl');
    IndexedDB.AddIDBIndex('ImageLen', 'imageLen');

    IndexedDB.IDBActiveIndex := 'AB_Nr';

    DataSourceDB.DataSet :=  IndexedDB;

    IndexedDB.FieldDefs.Clear;

    // add key field
    IndexedDB.FieldDefs.Add('id',ftInteger, 0, true);
    // make it a hidden column
    IndexedDB.FieldDefs.Items[0].Attributes :=  IndexedDB.FieldDefs.Items[0].Attributes + [faHiddenCol];

    // add normal fields
    IndexedDB.FieldDefs.Add('ab',ftString);
    IndexedDB.FieldDefs.Add('anlage',ftstring);
    IndexedDB.FieldDefs.Add('date',ftDate);
    IndexedDB.FieldDefs.Add('time',ftTime);
    IndexedDB.FieldDefs.Add('imageData',ftString);
    IndexedDB.FieldDefs.Add('imageUrl',ftString);
    IndexedDB.FieldDefs.Add('imageLen',ftInteger);

    IndexedDb.Active := true;

    keepAliveTimer.Interval := 1000;
    keepAliveTimer.OnTimer := getOnlineState;
    keepAliveTimer.Enabled := true;

end;

{ ***************************************************************************
 *  Wenn die Form angezeigt wird                                             *
  ***************************************************************************  }
procedure TForm2.WebFormShow(Sender: TObject);
var
    el: TJSElement;
begin
    IndexedDb.Active := true;

    el := document.getElementById('side2');
    el['class'] := 'active';
end;

{ ***************************************************************************
 *   Senden Button disablen                                                  *
  ***************************************************************************  }
procedure TForm2.WebRESTClient1Error(Sender: TObject; ARequest: TJSXMLHttpRequestRecord; Event: TJSEventRecord; var Handled: Boolean);
begin
    wbSendData.Enabled := false;
end;

{ ***************************************************************************
 *  Response Verarbeitung: KEEP_ALIVE, IMAGE_ACK                             *
  ***************************************************************************  }
procedure TForm2.WebRESTClient1Response(Sender: TObject; AResponse: string);
var
    o           : TJSONObject;
    param_ACK   : string;
    param_IMAGE : string;
begin
    if assigned(fJSONArray) then begin
        fJSONArray.Free;
    end;
    fJSONArray := TJSONArray.Create(nil);
    fJSONArray := TJSONObject.ParseJSONValue(AResponse) as TJSONArray;

    if (fJSONArray.Count > 0) and (fJSONArray <> nil) then begin
        o := fJSONArray.Items[0] as TJSONObject;

        if AResponse.Contains('KEEP_ALIVE') then
           param_ACK   := o.GetJSONValue('KEEP_ALIVE');

        if  AResponse.Contains('IMAGE_ACK') then
           param_IMAGE := o.GetJSONValue('IMAGE_ACK');
    end;

    if param_ACK = 'ACK_OK' then begin
        wbSendData.Enabled := true;
    end;

    if param_IMAGE = 'IMAGE_OK' then begin
        IndexedDB.Delete;
        if IndexedDB.RecordCount <> 0 then
            sendImage();
    end;end;

{ ***************************************************************************
 *   Ausgehlten IndexedDB Eintrag anzeigen                                  *
  ***************************************************************************  }
procedure TForm2.DBGridDBClickCell(Sender: TObject; ACol, ARow: Integer);
begin
    WebImageControl.Url := IndexedDB.FieldByName('imageData').AsString;
end;

{ ***************************************************************************
 *  Image versenden                                                          *
  ***************************************************************************  }
procedure TForm2.sendImage();
var
    ja: TJSONArray;
    jo: TJSONObject;
begin

    jo := TJSONObject.Create;
    jo.AddPair('AuftragsNummer', TJSONString.Create(IndexedDB.FieldByName('ab').AsString));
    jo.AddPair('Anlage', TJSONString.Create(IndexedDB.FieldByName('anlage').AsString));
    jo.AddPair('Datum', TJSONString.Create(IndexedDB.FieldByName('date').AsString));
    jo.AddPair('Zeit', TJSONString.Create(IndexedDB.FieldByName('time').AsString));
    jo.AddPair('ImageData', TJSONString.Create(IndexedDB.FieldByName('imageData').AsString));
    jo.AddPair('ImageUrl', TJSONString.Create(IndexedDB.FieldByName('imageUrl').AsString));
    jo.AddPair('ImageLen', TJSONString.Create(IndexedDB.FieldByName('imageLen').AsString));

    WebRESTClient1.HttpsPost('https://edv86.wolf-intranet.de:8080/serials', 'application/json', jo.ToString);
end;

{ ***************************************************************************
 *  call Image versenden                                                     *
  ***************************************************************************  }
procedure TForm2.wbSendDataClick(Sender: TObject);
begin
    sendImage();
end;

{ ***************************************************************************
 *   Eintrag aus IndexedDB lschen                                           *
  ***************************************************************************  }
procedure TForm2.wbDeleteClick(Sender: TObject);
begin
    IndexedDB.Delete;
end;

end.